# -*- mode: rpm-spec; -*-

%define version_major  1.0
%define version_relext 0.20030530

%define version_package 1.0-20030530

## for RedHat Linux
%define _with_cgi_bin /var/www/cgi-bin
## for Vine Linux
#define _with_cgi_bin /home/httpd/cgi-bin

%define _sysconfdir /etc/opensoap
%define _with_servicesdir /usr/lib/opensoap

%define _localstatedir /var/opensoap
# may need to be modified like /var/{log,spool,run}/opensoap

Summary: SOAP-based middleware for XML Web Services applications.
Summary(ja): XML WebӥץꥱSOAP١ߥɥ륦
Name: opensoap
Version: %{version_major}
Release: %{version_relext}
## for Vine Linux
#Release: %{version_relext}vl1
Epoch: 1
Group: System Environment/Libraries
Group(ja): ƥĶ/饤֥
BuildRequires: libxml2-devel, openssl-devel
Requires: libxml2, openssl
Source: www.opensoap.jp:/download/%{name}-%{version_package}.tar.gz
Copyright: BSD
URL: http://www.opensoap.jp/
BuildRoot: %{_tmppath}/%{name}-buildroot
#Patch: %{name}-%{version_package}.patch

%description
OpenSOAP provides an environment for XML Web Services.
API libraries to use SOAP (Simple Object Access Protocol) and the
server for service applications are provided.  Also Transaction and
Security functions are implemented.
This main package includes shared libraries for executing OpenSOAP
application software, and such basic tools as Soaping client/service
and Transaction service.

%description -l ja
OpenSOAPXML WebӥΤδĶ󶡤ޤSOAP (Simple Object
Access Protocol)Ѥ뤿API饤֥ȡӥץꥱ
ѤΤΥФ󶡤ȥ󥶥䥻ƥεǽ
Ƥޤ
ΥѥåˤϡOpenSOAPץꥱ󥽥եȼ¹Իɬפ
ͭ饤֥ꡢڤӡܥġǤSoaping饤/ӥ
Transactionӥޤޤޤ

%package devel
Summary: Libraries, include files to develop OpenSOAP applications.
Summary(ja): OpenSOAPץꥱȯΤΥ饤֥ȥإåե롣
Group: Development/Libraries
Group(ja): ȯ/饤֥
Requires: %{name} = %{version}

%description devel
Libraries, include-header files and documentation which can be used to
develop software based on SOAP for Web Services, and to compile the
source code for OpenSOAP application programs.

%description devel -l ja
Υ饤֥ȥإåե롢ڤӥɥѤ뤳Ȥǡ
WebӥΤSOAP̿Ѥ륽եȥȯꡢꤷ
OpenSOAPץꥱΥɤ򥳥ѥڤӥ󥯤뤳
ǽȤʤޤ

%package server
Summary: Server for the original OpenSOAP functions.
Summary(ja): OpenSOAPȼεǽ¸뤿ΥС
Group: System Environment/Daemons
Group(ja): ƥĶ/ǡ
Requires: %{name} = %{version}

%description server
The OpenSOAP Server supports operations for Web Service systems and
provides practical functions, such as asynchronous client connections
for non-real time processing, message forwarding for searching valid
services and passing through firewalls, and signing messages for
security validation.

%description server -l ja
OpenSOAPФϡ絬ϤWebӥƥαѤ򥵥ݡȤޤ
ӥꥢ륿бƱ饤³ǽ
õեۤ¸륵д֥åžǽ
ؤν̾ʤɤԤƥǽޤޤƤޤ

%package samples
Summary: Sample application programs of OpenSOAP.
Summary(ja): OpenSOAPΥץ륢ץꥱץࡣ
Group: Applications/Networking
Group(ja): ץꥱ/ͥåȥ
Requires: %{name} = %{version}

%description samples
This is a collection of simple sample application programs using
OpenSOAP.  Please try them if you just want to use OpenSOAP.  If you
are interested in developing application programs, please also refer
to the source codes.

%description samples -l ja
OpenSOAPץꥱδñʥץδ󤻽Ǥ
OpenSOAPȤꤢȤäƤߤˡ󤪻ץꥱ
ץ೫ȯ˶̣Τϡɤ⤴

%prep
%setup -q -n %{name}-%{version_package}
#%patch -p1

rm -rf $RPM_BUILD_ROOT

%build
%configure --sysconfdir=%{_sysconfdir} --with-servicesdir=%{_with_servicesdir} --with-cgi-bin=%{_with_cgi_bin} --localstatedir=%{_localstatedir}

## doc files to be copied
cp -pr doc docs
find docs -name 'Makefile*' -exec rm {} \;
rm -rf docs/api/*/Doxyfile
rm -rf docs/api/*/text/
cp -pr samples docs/

make

%install
make DESTDIR="$RPM_BUILD_ROOT" install
# samples
make DESTDIR="$RPM_BUILD_ROOT" install-samples

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 etc/init.d/opensoap.redhat \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/opensoap

%clean
rm -rf $RPM_BUILD_ROOT

%post server
# Register the opensoap service
/sbin/chkconfig --add opensoap

%preun server
if [ $1 = 0 ]; then
#	%{_sbindir}/opensoap-server-ctl stop || exit 0
	/sbin/service opensoap stop
	/sbin/chkconfig --del opensoap
fi

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)

%{_bindir}/soaping
%{_libdir}/libOpenSOAPClient.so.*
%{_libdir}/libOpenSOAPService.so.*
%{_libdir}/libOpenSOAPSecurity.so.*
%{_with_cgi_bin}/TransactionService.cgi
%{_with_cgi_bin}/SoapingService.cgi
%{_with_servicesdir}/Soaping
%{_with_servicesdir}/Transaction
%{_localstatedir}/services/Transaction
%{_mandir}/man1/*
%{_mandir}/ja/man1/*
%doc INSTALL INSTALL.ujis README README.ujis LICENSE
%doc HISTORY HISTORY.ujis TODO TODO.ujis
%doc docs/tools

%files devel
%defattr(-,root,root)

%{_includedir}/OpenSOAP
%{_libdir}/libOpenSOAPClient.so
%{_libdir}/libOpenSOAPService.so
%{_libdir}/libOpenSOAPSecurity.so
%{_libdir}/libOpenSOAPClient.*a
%{_libdir}/libOpenSOAPService.*a
%{_libdir}/libOpenSOAPSecurity.*a
%doc docs/api/en
%doc docs/api/ja
#%doc docs/security
#%doc docs/java

%files server
%defattr(-,root,root)

%{_sbindir}/*
%{_libdir}/libOpenSOAPServer.*
%{_libdir}/libHTTPMessage.*
%{_libdir}/libSOAPMessage.*
%{_libdir}/libconnection.*
%config %{_sysconfdir}/server.conf
%config %{_sysconfdir}/privKey.pem
%config %{_sysconfdir}/pubKey.pem
%{_sysconfdir}/*pem.default
%{_sysconfdir}/ssml/Soaping.ssml
%{_sysconfdir}/ssml/Transaction.ssml
%{_with_cgi_bin}/soapInterface.cgi
%{_mandir}/man8/*
%{_mandir}/ja/man8/*
%doc docs/server/*
%config /etc/rc.d/init.d/opensoap

%files samples
%defattr(-,root,root)

%doc docs/samples/*
%{_with_cgi_bin}/*Calc*
%{_with_cgi_bin}/Hello*
%{_with_cgi_bin}/GetCertService.cgi
%{_with_cgi_bin}/*Shopping*
%{_with_cgi_bin}/TransactionApp.cgi
%{_with_cgi_bin}/TransactionHtml
%{_with_cgi_bin}/TransactionABankService.cgi
%{_with_servicesdir}/*Calc*
%{_with_servicesdir}/*Hello*
%{_with_servicesdir}/GetCert
%{_with_servicesdir}/*Shopping*
%{_with_servicesdir}/TransactionABank
%{_bindir}/*Calc*
%{_bindir}/*Hello*
%{_bindir}/GetCertClient
%{_bindir}/registCA
# %{_bindir}/genrsakey
# %{_bindir}/secEnv
%{_bindir}/*Shopping*
%{_bindir}/TransactionClient
%{_sysconfdir}/ssml/*Calc*
%{_sysconfdir}/ssml/GetCert.ssml
%{_sysconfdir}/ssml/*Hello*
%{_sysconfdir}/ssml/*Shopping*
%{_sysconfdir}/ssml/TransactionABank.ssml
%{_localstatedir}/services/CalcAsync
%{_localstatedir}/services/GetCert
%{_localstatedir}/services/ShoppingSec

%changelog
* Fri Apr 11 2003 Nobuhito OKADA <okada@opensoap.jp> 1.0-0.20030531
- added init script
- added Epoch because versioning was confusing
- added man/ja/
- build opensoap-samples properly

* Sat Mar  1 2003 Nobuhito OKADA <okada@opensoap.jp> 1.0_20030228-2
- added %defattr
- removed Vendor
- corrected _with_cgi_bin (bug of define ?)

* Thu Feb 28 2003 Nobuhito OKADA <okada@opensoap.jp> 1.0_20030228-1
- Released as the first version.
