/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ChannelManager.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef ChannelManager_H
#define ChannelManager_H

#include <sys/types.h>
#include <string>

#include "Defines.h"

namespace OpenSOAP {

  //prototype def.
  class ChannelDescriptor;

  class ChannelManager {

  public:

	OPENSOAP_VAR
    ChannelManager();
	OPENSOAP_VAR
    virtual ~ChannelManager();

  public:

    //socket address w (run()sO)
#if defined(WIN32)
	OPENSOAP_VAR
    bool setSocketAddr(const int addr);
#else
    bool setSocketAddr(const std::string& addr);
#endif
    
    // Socket 쐬̍ۂ̃}XN̎w
#if defined(WIN32)
	OPENSOAP_VAR
    void setMask(int newMask);
#else
    void setMask(::mode_t newMask);
#endif
    //M҂sJn
	OPENSOAP_VAR
    void run();

  protected:
#if defined(WIN32)
	int
#else
    std::string 
#endif
		socketAddr_;
#if defined(WIN32)
	int
#else
	::mode_t 
#endif
		newMask_, curMask;
    bool setMaskFlag;
    //ʐM̃TuXbh
    //Xbh֐̎dlɂC{{NXł
    //  X^eBbN\bhłKvD
	static
#if defined(WIN32)
	void
#else
	void* 
#endif
		connectionThread(void* arg);

    //̃\bhTuNXɎD
    virtual void doProc(int sockfd);

    typedef struct ThrDataTag {
      ChannelManager* that;
      int sockfd;
    } ThrData;

  };

} // end of namespace OpenSOAP


#endif /* ChannelManager_H */
