/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: PIDFactory.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <iostream>

#include <unistd.h>
#include <fstream>

#include "PIDFactory.h"
#include "SrvConf.h"

using namespace OpenSOAP;
using namespace std;

//for LOG
static const std::string CLASS_SIG = "PIDFactory";

PIDFactory::PIDFactory()
{

}

PIDFactory::~PIDFactory()
{

}

bool
PIDFactory::makePID(const string& processName)
{
  SrvConf srvConf;
  string pidOutputFile = srvConf.getPIDPath();
  pidOutputFile += processName;

  pid_t pid = getpid();
  ofstream pidFile(pidOutputFile.c_str());
  if (!pidFile) {
    cerr << "Error: pid file [" 
         << pidOutputFile << "] cannot open!" << endl;
    return false;
  }
  pidFile << pid;
  pidFile.close();
  
  return true;
}
